import { IgrMultiSliderThumb } from "./igr-multi-slider-thumb";
import { MultiSliderThumbValueChangingEventArgs as MultiSliderThumbValueChangingEventArgs_internal } from "./MultiSliderThumbValueChangingEventArgs";
export class IgrMultiSliderThumbValueChangingEventArgs {
    createImplementation() {
        return new MultiSliderThumbValueChangingEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get value() {
        return this.i.b;
    }
    set value(v) {
        this.i.b = +v;
    }
    get thumb() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrMultiSliderThumb();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set thumb(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
}
