import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { MultiSliderThumb as MultiSliderThumb_internal } from './MultiSliderThumb';
import { IgrMultiSliderThumb as IgrMultiSliderThumb } from './igr-multi-slider-thumb';
var IgrMultiSliderThumbCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMultiSliderThumbCollection, _super);
    function IgrMultiSliderThumbCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrMultiSliderThumb.$type) {
            IgrMultiSliderThumb.$type = markType(IgrMultiSliderThumb, "IgrMultiSliderThumb");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrMultiSliderThumbCollection.prototype._createInnerColl = function () {
        if (!IgrMultiSliderThumb.$type) {
            IgrMultiSliderThumb.$type = markType(IgrMultiSliderThumb, "IgrMultiSliderThumb");
        }
        var coll = new SyncableObservableCollection$2(IgrMultiSliderThumb.$type, MultiSliderThumb_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrMultiSliderThumb();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrMultiSliderThumbCollection;
}(IgCollection));
export { IgrMultiSliderThumbCollection };
