import { Path } from "igniteui-react-core";
import { IList$1, Type } from "igniteui-react-core";
import { MultiSliderOrientation } from "./MultiSliderOrientation";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export interface IMultiSliderTrackRangeVisual {
    readonly thumbBox: Path;
    readonly thumbRidges: Path;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    translateX: number;
    translateY: number;
    orientation: MultiSliderOrientation;
    getThumbBoxDefaultStroke(): Brush;
    getThumbBoxDefaultStrokeThickness(): number;
    getThumbBoxDefaultBrush(): Brush;
    getThumbRidgesDefaultStroke(): Brush;
}
/**
 * @hidden
 */
export declare let IMultiSliderTrackRangeVisual_$type: Type;
