import { Path } from "igniteui-react-core";
import { IList$1, Type } from "igniteui-react-core";
import { MultiSliderTrackShadeOrientation } from "./MultiSliderTrackShadeOrientation";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export interface IMultiSliderTrackShadeVisual {
    readonly shadeBox: Path;
    readonly shadeOutline: Path;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    orientation: MultiSliderTrackShadeOrientation;
    translateX: number;
    translateY: number;
    getShadeBoxDefaultBrush(): Brush;
    getShadeOutlineDefaultBrush(): Brush;
    getShadeOutlineDefaultStrokeThickness(): number;
}
/**
 * @hidden
 */
export declare let IMultiSliderTrackShadeVisual_$type: Type;
