import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { IMultiSliderTrackThumbVisual } from "./IMultiSliderTrackThumbVisual";
import { IMultiSliderTrackRangeVisual } from "./IMultiSliderTrackRangeVisual";
import { IMultiSliderTrackBarVisual } from "./IMultiSliderTrackBarVisual";
import { IMultiSliderTrackThumbCalloutVisual } from "./IMultiSliderTrackThumbCalloutVisual";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { MultiSliderThumb } from "./MultiSliderThumb";
import { MultiSliderTrackThumbRange } from "./MultiSliderTrackThumbRange";
import { ISliderTrackOwner } from "./ISliderTrackOwner";
import { MultiSliderThumbCollection } from "./MultiSliderThumbCollection";
import { MultiSliderHitInfo } from "./MultiSliderHitInfo";
import { MultiSliderOrientation } from "./MultiSliderOrientation";
import { Brush } from "igniteui-react-core";
import { MultiSliderResolvingToolTipValueEventArgs } from "./MultiSliderResolvingToolTipValueEventArgs";
import { MultiSliderThumbValueChangingEventArgs } from "./MultiSliderThumbValueChangingEventArgs";
import { MultiSliderYValueChangingEventArgs } from "./MultiSliderYValueChangingEventArgs";
/**
 * @hidden
 */
export declare class MultiSliderView extends Base {
    static $t: Type;
    constructor(a: MultiSlider);
    at(): void;
    au(): void;
    private n;
    r: List$1<IMultiSliderTrackThumbVisual>;
    q: List$1<IMultiSliderTrackRangeVisual>;
    b: IMultiSliderTrackBarVisual;
    p: List$1<IMultiSliderTrackThumbCalloutVisual>;
    g: MultiSlider;
    aq(): void;
    ak(): void;
    private a6;
    private a0;
    private a2;
    private a1;
    private a5;
    private a4;
    private u;
    private v;
    private l;
    private t;
    private o;
    private x;
    private w;
    private j;
    private a;
    ap(): void;
    ax(a: any): void;
    private ah;
    private ai;
    private aj;
    private ab;
    ay(): void;
    ar(): void;
    private as;
    am(): void;
    k(): FontInfo;
    private i;
    private y;
    private s;
    a7(a: TextBlock, b: string, c: FontInfo): void;
    private h;
    private z;
    ae(): void;
    ag(): void;
    ad(): void;
    af(): void;
    ac(): void;
    a8(a: TextBlock): Size;
    aw(): void;
    a3(): void;
    ao(): void;
    private m;
    private an;
    av(): void;
    f(a: MultiSliderThumb): IMultiSliderTrackThumbVisual;
    az(a: MultiSliderThumb): void;
    e(a: MultiSliderThumb, b: number): IMultiSliderTrackThumbVisual;
    c(a: MultiSliderTrackThumbRange): IMultiSliderTrackRangeVisual;
    d(a: MultiSliderThumb): IMultiSliderTrackThumbCalloutVisual;
    al(a: (arg1: IMultiSliderTrackThumbCalloutVisual) => void): void;
}
/**
 * @hidden
 */
export declare class MultiSlider extends Base implements ISliderTrackOwner, INotifyPropertyChanged {
    static $t: Type;
    private g;
    get thumbs(): MultiSliderThumbCollection;
    private ag;
    protected get ah(): List$1<MultiSliderTrackThumbRange>;
    protected k: MultiSliderView;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private b1;
    private as;
    get bg(): number;
    set bg(a: number);
    private ar;
    get bf(): number;
    set bf(a: number);
    private aw;
    get bl(): number;
    set bl(a: number);
    private a2;
    get bu(): number;
    set bu(a: number);
    private a3;
    get bv(): number;
    set bv(a: number);
    private a5;
    get bx(): number;
    set bx(a: number);
    private at;
    get bh(): number;
    set bh(a: number);
    private ai;
    get a9(): number;
    set a9(a: number);
    resolvingToolTipValue: (sender: any, args: MultiSliderResolvingToolTipValueEventArgs) => void;
    ds(a: number, b: number, c: number, d: number): void;
    d8(): void;
    private ex;
    private x;
    get e1(): Rect;
    set e1(a: Rect);
    private a8;
    get b0(): number;
    set b0(a: number);
    private a4;
    get bw(): number;
    set bw(a: number);
    private aj;
    get ba(): number;
    set ba(a: number);
    private b;
    private a;
    private ew;
    private ev;
    dh(a: Point, b: boolean): void;
    private c5;
    dj(a: Point, b: number): void;
    af(a: Point, b: boolean): boolean;
    private ae;
    private dy;
    private ad;
    private y;
    di(a: Point): void;
    private dq;
    private bi;
    private c6;
    private dr;
    private d6;
    private dx;
    private e2;
    private e3;
    private o;
    private dd;
    df(a: Point): void;
    dg(a: Point): void;
    c(a: Point, b: boolean): MultiSliderHitInfo;
    private u;
    private v;
    private w;
    e0: Rect;
    ey: Rect;
    ez: Rect;
    private d3;
    private d0;
    private d5;
    private av;
    get bk(): number;
    set bk(a: number);
    private ap;
    get be(): number;
    set be(a: number);
    private a1;
    get bq(): number;
    set bq(a: number);
    private a0;
    get bp(): number;
    set bp(a: number);
    private a7;
    get bz(): number;
    set bz(a: number);
    private a6;
    get by(): number;
    set by(a: number);
    private ak;
    get bb(): number;
    set bb(a: number);
    private d;
    get e(): MultiSliderOrientation;
    set e(a: MultiSliderOrientation);
    private eh;
    get es(): Brush;
    set es(a: Brush);
    private ay;
    get bn(): number;
    set bn(a: number);
    private ei;
    get et(): Brush;
    set et(a: Brush);
    private az;
    get bo(): number;
    set bo(a: number);
    private ax;
    get bm(): number;
    set bm(a: number);
    destroy(): void;
    private d9;
    get ek(): Brush;
    set ek(a: Brush);
    private ea;
    get el(): Brush;
    set el(a: Brush);
    private al;
    get bc(): number;
    set bc(a: number);
    private ee;
    get ep(): Brush;
    set ep(a: Brush);
    private ef;
    get eq(): Brush;
    set eq(a: Brush);
    private au;
    get bj(): number;
    set bj(a: number);
    private eg;
    get er(): Brush;
    set er(a: Brush);
    private ej;
    get eu(): Brush;
    set eu(a: Brush);
    private eb;
    get em(): Brush;
    set em(a: Brush);
    private ed;
    get eo(): Brush;
    set eo(a: Brush);
    private ec;
    get en(): Brush;
    set en(a: Brush);
    private am;
    get bd(): number;
    set bd(a: number);
    get ac(): boolean;
    get aa(): boolean;
    get z(): boolean;
    get ab(): boolean;
    t: boolean;
    private n;
    p: FontInfo;
    protected dl(a: string, b: any, c: any): void;
    private q;
    private r;
    private du;
    private d1;
    private d2;
    private d7;
    private d4;
    private dm;
    private de;
    private dk;
    provideContainer(a: any): void;
    notifySizeChanged(): void;
    private ao;
    private an;
    private aq;
    constructor();
    private dz;
    private dn;
    private dp;
    private c9;
    c7(): void;
    private s;
    trackDirty(): void;
    updateActualPosition(a: number, b: number): number;
    updateThumbValue(a: number): number;
    updateThumbPosition(a: number): number;
    private br;
    private bt;
    private bs;
    thumbValueChanging: (sender: any, args: MultiSliderThumbValueChangingEventArgs) => void;
    thumbValueChanged: (sender: any, args: MultiSliderThumbValueChangingEventArgs) => void;
    yValueChanging: (sender: any, args: MultiSliderYValueChangingEventArgs) => void;
    yValueChanged: (sender: any, args: MultiSliderYValueChangingEventArgs) => void;
    onThumbValueUpdated(a: any, b: number, c: number): void;
    private dt;
    dw(): void;
    c8(): void;
}
