import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { INativeUIElementFactory } from "igniteui-react-core";
import { NativeUIElementFactoryFlavor } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { NativeUIComponentBuiltInType } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { XComponentBridge } from "./XComponentBridge";
import { NativeUIBuiltInEvents } from "igniteui-react-core";
import { ColorEditorPanelSelectedValueChangedEventArgs } from "./ColorEditorPanelSelectedValueChangedEventArgs";
import { NativeUIBuiltInProperties } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { IExecutionContext } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { ColorEditorPanelClosedEventArgs } from "./ColorEditorPanelClosedEventArgs";
import { ColorEditorGotFocusEventArgs } from "./ColorEditorGotFocusEventArgs";
import { ColorEditorLostFocusEventArgs } from "./ColorEditorLostFocusEventArgs";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class NativeUIXInputsFactory extends Base implements INativeUIElementFactory {
    static $t: Type;
    private static a;
    static get b(): NativeUIXInputsFactory;
    static m(): void;
    private c;
    get flavor(): NativeUIElementFactoryFlavor;
    createComponent(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    createComponentSync(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    supportsComponent(a: NativeUIComponentBuiltInType): boolean;
    private j;
    private d;
    private l;
    private e;
    private g;
    private f;
    private i;
    private h;
    private k;
}
/**
 * @hidden
 */
export declare class ColorEditorBridge extends XComponentBridge {
    static $t: Type;
    constructor(a: any);
    private u;
    private w;
    private v;
    private x;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    private y;
    private z;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
}
/**
 * @hidden
 */
export declare class ColorEditorPanelView extends Base {
    static $t: Type;
    constructor();
    a: ColorEditorPanel;
    bj(): void;
    f(): boolean;
    aa: DomRenderer;
    private c;
    private g;
    bh(a: DomRenderer): void;
    bd(): void;
    private d;
    private af;
    private o;
    private n;
    private ab;
    private b;
    private ac;
    private a1;
    private ag;
    private ae;
    bg(): void;
    bi(): void;
    a7(): any;
    bf(a: Size): void;
    a8(a: NativeUIGrid): void;
    private be;
    private m;
    private l;
    private au;
    private at;
    ba(a: NativeUIContent): void;
    private a3;
    private k;
    bm(a: number): void;
    private j;
    private h;
    a9(a: NativeUIContent): void;
    private i;
    private a2;
    private bl;
    private t;
    private p;
    private aw;
    private av;
    bb(a: NativeUIGrid): void;
    private z;
    private v;
    private a0;
    private az;
    bc(a: NativeUIContent): void;
    private u;
    private a6;
    private ai;
    private w;
    private s;
    private r;
    private ay;
    private ax;
    bn(a: number): void;
    private a5;
    private y;
    private x;
    private ad;
    private ak;
    private ao;
    private as;
    private ar;
    private aj;
    private an;
    private ah;
    private al;
    private ap;
    private am;
    private aq;
    private a4;
    private q;
    bo(a: number, b: number, c: number): void;
    private e;
    bk(): void;
}
/**
 * @hidden
 */
export declare class ColorEditorView extends Base {
    static $t: Type;
    constructor();
    a: ColorEditor;
    q(): void;
    f(): boolean;
    h: DomRenderer;
    private d;
    private g;
    o(a: DomRenderer): void;
    m(): void;
    private e;
    n(): void;
    p(): void;
    j(): any;
    private b;
    i(): any;
    k(a: NativeUIContent, b: any): void;
    l(a: NativeUIComponent): void;
    c(a: any): ColorEditorPanel;
    r(a: boolean): Rect;
    s(): Size;
}
/**
 * @hidden
 */
export declare class ColorEditor extends Base implements INotifyPropertyChanged {
    static $t: Type;
    g: ColorEditorView;
    private static readonly a5;
    private r;
    private q;
    private d;
    private v;
    private af;
    private ad;
    private cj;
    private w;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    valueChanged: (sender: any, args: ColorEditorPanelSelectedValueChangedEventArgs) => void;
    valueChanging: (sender: any, args: ColorEditorPanelSelectedValueChangedEventArgs) => void;
    b1(a: Brush, b: Brush): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private s;
    private get t();
    a: IExecutionContext;
    private cl;
    get value(): Brush;
    set value(a: Brush);
    private ar;
    get az(): string;
    set az(a: string);
    private ci;
    get cn(): Brush;
    set cn(a: Brush);
    private static n;
    private l;
    get o(): FontInfo;
    set o(a: FontInfo);
    private j;
    get k(): ControlDisplayDensity;
    set k(a: ControlDisplayDensity);
    private h;
    get i(): BaseControlTheme;
    set i(a: BaseControlTheme);
    private m;
    get p(): FontInfo;
    set p(a: FontInfo);
    private ck;
    get co(): Brush;
    set co(a: Brush);
    private ch;
    get cm(): Brush;
    set cm(a: Brush);
    private ac;
    get am(): boolean;
    set am(a: boolean);
    private u;
    get ag(): boolean;
    set ag(a: boolean);
    private ab;
    get ak(): boolean;
    set ak(a: boolean);
    private x;
    get ah(): boolean;
    set ah(a: boolean);
    private ap;
    get aq(): number;
    set aq(a: number);
    private y;
    get ai(): boolean;
    set ai(a: boolean);
    private aa;
    get aj(): boolean;
    set aj(a: boolean);
    private ae;
    get an(): boolean;
    set an(a: boolean);
    protected b0(a: string, b: any, c: any): void;
    protected b6(a: string, b: any, c: any): void;
    private al;
    private cg;
    private ce;
    private cf;
    be(): void;
    private z;
    by(): void;
    bz(): void;
    bo(): void;
    bs(): void;
    private b3;
    private b4;
    bg(): void;
    private bd;
    private bc;
    private bx;
    private bv;
    private cc;
    private bj;
    private b2;
    private bi;
    cd(): void;
    b5(): void;
    private cb;
    bf(): void;
    focus(a?: boolean): void;
    bm(): void;
    b8(): void;
    bl(): void;
    bq(): void;
    br(): void;
    private ca;
    private b9;
    gotFocus: (sender: any, args: ColorEditorGotFocusEventArgs) => void;
    lostFocus: (sender: any, args: ColorEditorLostFocusEventArgs) => void;
    bu(a: ColorEditorGotFocusEventArgs): void;
    bw(a: ColorEditorLostFocusEventArgs): void;
}
/**
 * @hidden
 */
export declare class ColorEditorPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    d: ColorEditorPanelView;
    private static readonly ag;
    private static readonly ah;
    bv: Brush;
    private bo;
    private bs;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    closed: (sender: any, args: ColorEditorPanelClosedEventArgs) => void;
    a8(): void;
    valueChanged: (sender: any, args: ColorEditorPanelSelectedValueChangedEventArgs) => void;
    valueChanging: (sender: any, args: ColorEditorPanelSelectedValueChangedEventArgs) => void;
    bc(a: Brush): void;
    notifySizeChanged(a: Size): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private v;
    private get w();
    private bx;
    get value(): Brush;
    set value(a: Brush);
    private g;
    get h(): ControlDisplayDensity;
    set h(a: ControlDisplayDensity);
    private e;
    get f(): BaseControlTheme;
    set f(a: BaseControlTheme);
    private bp;
    get by(): Brush;
    set by(a: Brush);
    private bt;
    get b1(): Brush;
    set b1(a: Brush);
    private bu;
    get b2(): Brush;
    set b2(a: Brush);
    private bq;
    get bz(): Brush;
    set bz(a: Brush);
    private br;
    get b0(): Brush;
    set b0(a: Brush);
    private bw;
    get b3(): Brush;
    set b3(a: Brush);
    private i;
    private n;
    private s;
    private u;
    private m;
    private t;
    private o;
    private r;
    private q;
    private l;
    private k;
    private p;
    get j(): FontInfo;
    set j(a: FontInfo);
    private aa;
    get ae(): number;
    set ae(a: number);
    private z;
    get ab(): number;
    set ab(a: number);
    protected bb(a: string, b: any, c: any): void;
    protected bd(a: string, b: any, c: any): void;
    a4(): void;
    private bh;
    private a6;
    private av;
    private aw;
    private y;
    private bn;
    private au;
    private bk;
    private bl;
    a3(): void;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    private bj;
    private bi;
    ax(): void;
    get b5(): Color;
    private bf;
    private bm;
    bg(): void;
    private x;
    ba(): void;
    a0(a: number[], b: number, c: number): void;
    az(a: number[], b: number, c: number): void;
    ad(): number;
    a1(a: number[], b: number, c: number): void;
    a2(a: number[], b: number, c: number): void;
}
