import { MultiSliderThumbRangePosition } from "./MultiSliderThumbRangePosition";
import { IgrMultiSliderTrackThumbRange } from "./igr-multi-slider-track-thumb-range";
import { IgrPropertyUpdatedEventArgs } from "igniteui-react-core";
import { MultiSliderThumb as MultiSliderThumb_internal } from "./MultiSliderThumb";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrMultiSliderThumb {
    protected createImplementation(): MultiSliderThumb_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): MultiSliderThumb_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get value(): number;
    set value(v: number);
    get rangePosition(): MultiSliderThumbRangePosition;
    set rangePosition(v: MultiSliderThumbRangePosition);
    get range(): IgrMultiSliderTrackThumbRange;
    set range(v: IgrMultiSliderTrackThumbRange);
    findByName(name: string): any;
    push(amount: number): number;
    private _propertyUpdated;
    private _propertyUpdated_wrapped;
    get propertyUpdated(): (s: IgrMultiSliderThumb, e: IgrPropertyUpdatedEventArgs) => void;
    set propertyUpdated(ev: (s: IgrMultiSliderThumb, e: IgrPropertyUpdatedEventArgs) => void);
}
