import { ColorEditorPanelSelectedValueChangedEventArgs as ColorEditorPanelSelectedValueChangedEventArgs_internal } from "./ColorEditorPanelSelectedValueChangedEventArgs";
import { brushToString, stringToBrush } from "igniteui-react-core";
export class IgrColorEditorPanelSelectedValueChangedEventArgs {
    createImplementation() {
        return new ColorEditorPanelSelectedValueChangedEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get oldValue() {
        return brushToString(this.i.oldValue);
    }
    set oldValue(v) {
        this.i.oldValue = stringToBrush(v);
    }
    get newValue() {
        return brushToString(this.i.newValue);
    }
    set newValue(v) {
        this.i.newValue = stringToBrush(v);
    }
}
