import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { MultiSliderThumb as MultiSliderThumb_internal } from './MultiSliderThumb';
import { IgrMultiSliderThumb as IgrMultiSliderThumb } from './igr-multi-slider-thumb';
export class IgrMultiSliderThumbCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrMultiSliderThumb.$type) {
            IgrMultiSliderThumb.$type = markType(IgrMultiSliderThumb, "IgrMultiSliderThumb");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrMultiSliderThumb.$type) {
            IgrMultiSliderThumb.$type = markType(IgrMultiSliderThumb, "IgrMultiSliderThumb");
        }
        let coll = new SyncableObservableCollection$2(IgrMultiSliderThumb.$type, MultiSliderThumb_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrMultiSliderThumb();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
