/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { XComponentBridge } from "./XComponentBridge";
import { runOn, delegateCombine, enumGetBox, delegateRemove, EnumUtil, markType } from "igniteui-react-core";
import { NativeUISliderValueChangedEventArgs } from "igniteui-react-core";
import { NativeUISliderOrientation_$type } from "igniteui-react-core";
/**
 * @hidden
 */
var MultiSliderBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MultiSliderBridge, _super);
    function MultiSliderBridge(a) {
        var _this = _super.call(this, a) || this;
        _this.u = null;
        _this.w = null;
        _this.v = null;
        _this.x = null;
        return _this;
    }
    MultiSliderBridge.prototype.addHandler = function (a, b, c, d) {
        switch (c) {
            case 0:
                var e = a;
                e.thumbValueChanging = delegateCombine(e.thumbValueChanging, runOn(this, this.z));
                var f = a;
                f.yValueChanging = delegateCombine(f.yValueChanging, runOn(this, this.ab));
                this.v = d;
                this.x = b;
                break;
            case 4:
                var g = a;
                g.thumbValueChanged = delegateCombine(g.thumbValueChanged, runOn(this, this.y));
                var h = a;
                h.yValueChanged = delegateCombine(h.yValueChanged, runOn(this, this.aa));
                this.u = d;
                this.w = b;
                break;
        }
    };
    MultiSliderBridge.prototype.y = function (a, b) {
        if (this.u != null) {
            var c = new NativeUISliderValueChangedEventArgs();
            this.u(this.w, c);
        }
    };
    MultiSliderBridge.prototype.aa = function (a, b) {
        if (this.u != null) {
            var c = new NativeUISliderValueChangedEventArgs();
            this.u(this.w, c);
        }
    };
    MultiSliderBridge.prototype.z = function (a, b) {
        if (this.v != null) {
            var c = new NativeUISliderValueChangedEventArgs();
            this.v(this.x, c);
        }
    };
    MultiSliderBridge.prototype.ab = function (a, b) {
        if (this.v != null) {
            var c = new NativeUISliderValueChangedEventArgs();
            this.v(this.x, c);
        }
    };
    MultiSliderBridge.prototype.getValue = function (a, b) {
        switch (b) {
            case 12: return a.bg;
            case 13: return a.bf;
            case 94: return a.bv;
            case 95: return a.bf;
            case 14: return a.bl;
            case 2: return a.thumbs._inner[0].s;
            case 89: return a.b0;
            case 90: return a.ek;
            case 91: return a.es;
            case 93: return a.eu;
            case 92: return a.et;
            case 30:
                var c = a.e;
                switch (c) {
                    case 0: return enumGetBox(NativeUISliderOrientation_$type, 0);
                    case 1: return enumGetBox(NativeUISliderOrientation_$type, 1);
                    case 2: return enumGetBox(NativeUISliderOrientation_$type, 2);
                }
                break;
        }
        return null;
    };
    MultiSliderBridge.prototype.removeHandler = function (a, b, c, d) {
        switch (c) {
            case 0:
                var e = a;
                e.thumbValueChanging = delegateRemove(e.thumbValueChanging, runOn(this, this.z));
                var f = a;
                f.yValueChanging = delegateRemove(f.yValueChanging, runOn(this, this.ab));
                this.v = null;
                this.x = null;
                break;
            case 4:
                var g = a;
                g.thumbValueChanged = delegateRemove(g.thumbValueChanged, runOn(this, this.y));
                var h = a;
                h.yValueChanged = delegateRemove(h.yValueChanged, runOn(this, this.aa));
                this.u = null;
                this.w = null;
                break;
        }
    };
    MultiSliderBridge.prototype.setValue = function (a, b, c) {
        switch (b) {
            case 12:
                a.bg = c;
                break;
            case 13:
                a.bf = c;
                break;
            case 94:
                a.bv = c;
                break;
            case 95:
                a.bu = c;
                break;
            case 14:
                a.bl = c;
                break;
            case 2:
                a.thumbs._inner[0].s = c;
                break;
            case 89:
                a.b0 = c;
                break;
            case 90:
                a.ek = c;
                break;
            case 91:
                a.es = c;
                break;
            case 93:
                a.eu = c;
                break;
            case 92:
                a.et = c;
                break;
            case 30:
                var d = EnumUtil.getEnumValue(NativeUISliderOrientation_$type, c);
                switch (d) {
                    case 0:
                        a.e = 0;
                        break;
                    case 1:
                        a.e = 1;
                        break;
                    case 2:
                        a.e = 2;
                        break;
                }
                break;
        }
    };
    MultiSliderBridge.$t = markType(MultiSliderBridge, 'MultiSliderBridge', XComponentBridge.$);
    return MultiSliderBridge;
}(XComponentBridge));
export { MultiSliderBridge };
