/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, runOn, delegateCombine, delegateRemove, Delegate_$type, fromEnum, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-react-core";
import { INativeUIElementFactory_$type } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XInput } from "./XInput";
import { XInputBridge } from "./XInputBridge";
import { NativeUIInput } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XButton } from "./XButton";
import { XButtonBridge } from "./XButtonBridge";
import { NativeUIButton } from "igniteui-react-core";
import { MultiSlider } from "./MultiSlider";
import { MultiSliderThumb } from "./MultiSliderThumb";
import { MultiSliderBridge } from "./MultiSliderBridge";
import { NativeUISlider } from "igniteui-react-core";
import { XButtonGroup } from "./XButtonGroup";
import { XButtonGroupBridge } from "./XButtonGroupBridge";
import { NativeUIButtonGroup } from "igniteui-react-core";
import { NativeUIColorEditor } from "igniteui-react-core";
import { XCheckbox } from "./XCheckbox";
import { XCheckboxBridge } from "./XCheckboxBridge";
import { NativeUICheckbox } from "igniteui-react-core";
import { XIcon } from "./XIcon";
import { XIconBridge } from "./XIconBridge";
import { NativeUIIcon } from "igniteui-react-core";
import { Popup } from "igniteui-react-core";
import { XPopupBridge } from "./XPopupBridge";
import { NativeUIPopup } from "igniteui-react-core";
import { XComponentBridge } from "./XComponentBridge";
import { ColorEditorPanelSelectedValueChangedEventArgs } from "./ColorEditorPanelSelectedValueChangedEventArgs";
import { NativeUIColorEditorValueChangedEventArgs } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { truncate, isNaN_, intDivide } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { NativeUIWindow } from "igniteui-react-core";
import { ColorEditorPanelClosedEventArgs } from "./ColorEditorPanelClosedEventArgs";
import { ColorEditorGotFocusEventArgs } from "./ColorEditorGotFocusEventArgs";
import { ColorEditorLostFocusEventArgs } from "./ColorEditorLostFocusEventArgs";
import { Color } from "igniteui-react-core";
import { ColorUtil } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
/**
 * @hidden
 */
var NativeUIXInputsFactory = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NativeUIXInputsFactory, _super);
    function NativeUIXInputsFactory() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 2;
        return _this;
    }
    Object.defineProperty(NativeUIXInputsFactory, "b", {
        get: function () {
            if (NativeUIXInputsFactory.a == null) {
                NativeUIXInputsFactory.a = new NativeUIXInputsFactory();
            }
            return NativeUIXInputsFactory.a;
        },
        enumerable: false,
        configurable: true
    });
    NativeUIXInputsFactory.m = function () {
        NativeUIComponent.as(NativeUIXInputsFactory.b);
    };
    Object.defineProperty(NativeUIXInputsFactory.prototype, "flavor", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    NativeUIXInputsFactory.prototype.createComponent = function (a, b, c) {
        switch (b) {
            case 1:
                this.d(a, c);
                break;
            case 6:
                this.f(a, c);
                break;
            case 10:
                this.i(a, c);
                break;
            case 2:
                this.j(a, c);
                break;
            case 11:
                this.h(a, c);
                break;
            case 12:
                this.k(a, c);
                break;
            case 17:
                this.e(a, c);
                break;
            case 20:
                this.g(a, c);
                break;
            case 5:
                this.l(a, c);
                break;
        }
    };
    NativeUIXInputsFactory.prototype.createComponentSync = function (a, b, c) {
        this.createComponent(a, b, c);
    };
    NativeUIXInputsFactory.prototype.supportsComponent = function (a) {
        switch (a) {
            case 1: return true;
            case 6: return true;
            case 10: return true;
            case 2: return true;
            case 11: return true;
            case 12: return true;
            case 17: return true;
            case 20: return true;
            case 5: return true;
        }
        return false;
    };
    NativeUIXInputsFactory.prototype.j = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XInputGroup();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, null);
        var h = c.createElement("div");
        h.setRawStyleProperty("width", "100%");
        var i = c.getSubRenderer(h);
        var j = new XInput();
        j.provideContainer(i);
        var k = e.getExternal(j, i.rootWrapper, null);
        f.appendContentChild(h);
        f.inputs.add(j);
        var l = new XInputBridge(f);
        var m = new NativeUIInput();
        m.an = d;
        m.d = l;
        b(m);
    };
    NativeUIXInputsFactory.prototype.d = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XButton();
        f.provideContainer(e);
        f.ff = "none";
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XButtonBridge(f);
        var i = new NativeUIButton();
        i.an = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.l = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new MultiSlider();
        var g = new MultiSliderThumb();
        f.provideContainer(e);
        f.thumbs.add(g);
        var h = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var i = new MultiSliderBridge(f);
        var j = new NativeUISlider();
        j.an = d;
        j.d = i;
        b(j);
    };
    NativeUIXInputsFactory.prototype.e = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XButtonGroup();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XButtonGroupBridge(f);
        var i = new NativeUIButtonGroup();
        i.an = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.g = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new ColorEditor();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new ColorEditorBridge(f);
        var i = new NativeUIColorEditor();
        i.an = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.f = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XCheckbox();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XCheckboxBridge(f);
        var i = new NativeUICheckbox();
        i.an = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.i = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XIcon();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XIconBridge(f);
        var i = new NativeUIIcon();
        i.an = d;
        i.d = h;
        var j = c.createElement("div");
        var k = c.getSubRenderer(j);
        var l = new XButton();
        l.provideContainer(k);
        l.e = 4;
        l.ff = "none";
        var m = k.getExternal(l, k.rootWrapper, k.getExternal(l, null, null));
        var n = new XButtonBridge(l);
        var o = new NativeUIButton();
        o.an = j;
        o.d = n;
        o.bo = i;
        b(o);
    };
    NativeUIXInputsFactory.prototype.h = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new XIcon();
        f.provideContainer(e);
        var g = e.getExternal(f, e.rootWrapper, e.getExternal(f, null, null));
        var h = new XIconBridge(f);
        var i = new NativeUIIcon();
        i.an = d;
        i.d = h;
        b(i);
    };
    NativeUIXInputsFactory.prototype.k = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new Popup();
        f.provideRenderer(e);
        var g = new XPopupBridge(f);
        var h = new NativeUIPopup();
        h.an = d;
        h.d = g;
        b(h);
    };
    NativeUIXInputsFactory.$t = markType(NativeUIXInputsFactory, 'NativeUIXInputsFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUIXInputsFactory.a = null;
    return NativeUIXInputsFactory;
}(Base));
export { NativeUIXInputsFactory };
/**
 * @hidden
 */
var ColorEditorBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorEditorBridge, _super);
    function ColorEditorBridge(a) {
        var _this = _super.call(this, a) || this;
        _this.u = null;
        _this.w = null;
        _this.v = null;
        _this.x = null;
        return _this;
    }
    ColorEditorBridge.prototype.addHandler = function (a, b, c, d) {
        switch (c) {
            case 0:
                var e = a;
                e.valueChanging = delegateCombine(e.valueChanging, runOn(this, this.z));
                this.v = d;
                this.x = b;
                break;
            case 4:
                var f = a;
                f.valueChanged = delegateCombine(f.valueChanged, runOn(this, this.y));
                this.u = d;
                this.w = b;
                break;
        }
    };
    ColorEditorBridge.prototype.y = function (a, b) {
        if (this.u != null) {
            var c = new NativeUIColorEditorValueChangedEventArgs();
            this.u(this.w, c);
        }
    };
    ColorEditorBridge.prototype.z = function (a, b) {
        if (this.v != null) {
            var c = new NativeUIColorEditorValueChangedEventArgs();
            this.v(this.x, c);
        }
    };
    ColorEditorBridge.prototype.getValue = function (a, b) {
        switch (b) {
            case 2: return a.value;
        }
        return null;
    };
    ColorEditorBridge.prototype.removeHandler = function (a, b, c, d) {
        switch (c) {
            case 0:
                var e = a;
                e.valueChanging = delegateRemove(e.valueChanging, runOn(this, this.z));
                this.v = null;
                this.x = null;
                break;
            case 4:
                var f = a;
                f.valueChanged = delegateRemove(f.valueChanged, runOn(this, this.y));
                this.u = null;
                this.w = null;
                break;
        }
    };
    ColorEditorBridge.prototype.setValue = function (a, b, c) {
        switch (b) {
            case 2:
                a.value = c;
                break;
        }
    };
    ColorEditorBridge.$t = markType(ColorEditorBridge, 'ColorEditorBridge', XComponentBridge.$);
    return ColorEditorBridge;
}(XComponentBridge));
export { ColorEditorBridge };
/**
 * @hidden
 */
var ColorEditorPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorEditorPanelView, _super);
    function ColorEditorPanelView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.aa = null;
        _this.c = null;
        _this.g = new List$1(Delegate_$type, 0);
        _this.d = true;
        _this.af = null;
        _this.o = NaN;
        _this.n = NaN;
        _this.ab = null;
        _this.b = null;
        _this.ac = null;
        _this.a1 = null;
        _this.ag = null;
        _this.ae = null;
        _this.m = -1;
        _this.l = -1;
        _this.au = -1;
        _this.at = -1;
        _this.a3 = null;
        _this.k = -1;
        _this.j = -1;
        _this.h = -1;
        _this.i = -1;
        _this.a2 = null;
        _this.t = -1;
        _this.p = -1;
        _this.aw = -1;
        _this.av = -1;
        _this.z = -1;
        _this.v = -1;
        _this.a0 = -1;
        _this.az = -1;
        _this.u = -1;
        _this.a6 = null;
        _this.ai = null;
        _this.w = -1;
        _this.s = -1;
        _this.r = -1;
        _this.ay = -1;
        _this.ax = -1;
        _this.a5 = null;
        _this.y = -1;
        _this.x = -1;
        _this.ad = null;
        _this.ak = null;
        _this.ao = null;
        _this.as = -1;
        _this.ar = -1;
        _this.aj = null;
        _this.an = null;
        _this.ah = null;
        _this.al = null;
        _this.ap = null;
        _this.am = null;
        _this.aq = null;
        _this.a4 = null;
        _this.q = -1;
        _this.e = false;
        return _this;
    }
    ColorEditorPanelView.prototype.bj = function () {
    };
    ColorEditorPanelView.prototype.f = function () {
        return true;
    };
    ColorEditorPanelView.prototype.bh = function (a) {
        var e_1, _a;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.g.clear();
            return;
        }
        this.aa = a;
        if (isNaN_(this.a.ae)) {
            this.a.ab = window.devicePixelRatio;
        }
        this.a.a4();
    };
    ColorEditorPanelView.prototype.bd = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.aa;
        }
    };
    ColorEditorPanelView.prototype.bg = function () {
        this.d = true;
    };
    ColorEditorPanelView.prototype.bi = function () {
        this.d = false;
    };
    ColorEditorPanelView.prototype.a7 = function () {
        return this.aa;
    };
    ColorEditorPanelView.prototype.bf = function (a) {
    };
    ColorEditorPanelView.prototype.a8 = function (a) {
        this.aa.append(this.aa.getWrapper(a.an));
    };
    ColorEditorPanelView.prototype.be = function (a, b, c, d, e, f, g) {
        var h = truncate(Math.round(f * this.a.ab));
        var i = truncate(Math.round(g * this.a.ab));
        if (f != b || g != c || h != d || i != e) {
            a.setProperty("width", h);
            a.setProperty("height", i);
            a.setStyleProperty("width", f + "px");
            a.setStyleProperty("height", g + "px");
            b = f;
            c = g;
            d = h;
            e = i;
        }
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    };
    ColorEditorPanelView.prototype.ba = function (a) {
        if (this.ae == null || a.ao == null) {
            a.ao = "image";
            var b = this.aa.createElement("canvas");
            this.ae = b;
            var c = this.be(this.ae, this.m, this.l, this.au, this.at, 148, 148);
            this.m = c.p1;
            this.l = c.p2;
            this.au = c.p3;
            this.at = c.p4;
            this.ae.setStyleProperty("justify-self", "center");
            this.ae.setStyleProperty("align-self", "center");
            var d = a.an;
            d.append(this.ae);
            this.bm(this.a.ad());
        }
    };
    ColorEditorPanelView.prototype.bm = function (a) {
        if (this.k == a && !this.e) {
            return;
        }
        if (this.ae != null) {
            this.k = a;
            var b = this.be(this.ae, this.m, this.l, this.au, this.at, 148, 148);
            this.m = b.p1;
            this.l = b.p2;
            this.au = b.p3;
            this.at = b.p4;
            var c = this.au;
            var d = this.at;
            var e = this.a3;
            if (this.ak == null) {
                var f = (this.ae.getNativeElement());
                var g = f.getContext("2d");
                this.ak = g;
            }
            if (e == null || e.length != (c * d) * 4) {
                this.ao = this.ak.getImageData(0, 0, c, d);
                e = this.ao.data;
                this.a3 = e;
            }
            this.a.a0(e, c, d);
            this.ak.putImageData(this.ao, 0, 0);
        }
    };
    ColorEditorPanelView.prototype.a9 = function (a) {
        if (this.ad == null || a.ao == null) {
            a.ao = "image";
            var b = this.aa.createElement("canvas");
            this.ad = b;
            var c = this.be(this.ad, this.j, this.h, this.as, this.ar, 248, 19);
            this.j = c.p1;
            this.h = c.p2;
            this.as = c.p3;
            this.ar = c.p4;
            this.ad.setStyleProperty("justify-self", "center");
            this.ad.setStyleProperty("align-self", "center");
            var d = a.an;
            d.append(this.ad);
            this.bl(0);
        }
    };
    ColorEditorPanelView.prototype.bl = function (a) {
        if (a == this.i && !this.e) {
            return;
        }
        if (this.ad != null) {
            this.i = a;
            var b = this.be(this.ad, this.j, this.h, this.as, this.ar, 248, 19);
            this.j = b.p1;
            this.h = b.p2;
            this.as = b.p3;
            this.ar = b.p4;
            var c = this.as;
            var d = this.ar;
            var e = this.a2;
            if (this.aj == null) {
                var f = (this.ad.getNativeElement());
                var g = f.getContext("2d");
                this.aj = g;
            }
            if (e == null || e.length != (c * d) * 4) {
                this.an = this.aj.getImageData(0, 0, c, d);
                e = this.an.data;
                this.a2 = e;
            }
            this.a.az(e, c, d);
            this.aj.putImageData(this.an, 0, 0);
        }
    };
    ColorEditorPanelView.prototype.bb = function (a) {
        var b = a.an;
        if (b.getChildCount() == 1) {
            a.ao = "image";
            var c = this.aa.createElement("canvas");
            this.ah = c;
            var d = this.be(this.ah, this.t, this.p, this.aw, this.av, 85, 148);
            this.t = d.p1;
            this.p = d.p2;
            this.aw = d.p3;
            this.av = d.p4;
            this.ah.setStyleProperty("margin-left", "5px");
            this.ah.setStyleProperty("margin-top", "16px");
            this.ah.setStyleProperty("margin-right", "0px");
            this.ah.setStyleProperty("margin-bottom", "11px");
            this.ah.setStyleProperty("grid-row-start", "1");
            this.ah.setStyleProperty("grid-row-end", "2");
            this.ah.setStyleProperty("grid-column-start", "1");
            this.ah.setStyleProperty("grid-column-end", "2");
            this.bn(0);
            var e = b.getChildAt(0);
            e.before(c);
        }
    };
    ColorEditorPanelView.prototype.bc = function (a) {
        if (this.ai == null || a.ao == null) {
            a.ao = "image";
            var b = this.aa.createElement("canvas");
            this.ai = b;
            var c = this.be(this.ai, this.z, this.v, this.aw, this.av, 25, 148);
            this.z = c.p1;
            this.v = c.p2;
            this.aw = c.p3;
            this.av = c.p4;
            this.ai.setStyleProperty("justify-self", "center");
            this.ai.setStyleProperty("align-self", "center");
            var d = a.an;
            d.append(this.ai);
            this.bo(0, 1, 0.5);
        }
    };
    ColorEditorPanelView.prototype.bn = function (a) {
        if (this.q == a && !this.e) {
            return;
        }
        if (this.ah != null) {
            this.q = a;
            var b = this.be(this.ah, this.s, this.r, this.ay, this.ax, 85, 148);
            this.s = b.p1;
            this.r = b.p2;
            this.ay = b.p3;
            this.ax = b.p4;
            var c = this.ay;
            var d = this.ax;
            var e = this.a4;
            if (this.al == null) {
                var f = (this.ah.getNativeElement());
                var g = f.getContext("2d");
                this.al = g;
            }
            if (e == null || e.length != (c * d) * 4) {
                this.ap = this.al.getImageData(0, 0, c, d);
                e = this.ap.data;
                this.a4 = e;
            }
            this.a.a1(e, c, d);
            this.al.putImageData(this.ap, 0, 0);
        }
    };
    ColorEditorPanelView.prototype.bo = function (a, b, c) {
        if (this.w == a && this.y == b && this.x == c && !this.e) {
            return;
        }
        if (this.ai != null) {
            this.w = a;
            this.y = b;
            this.x = c;
            var d = this.be(this.ai, this.z, this.v, this.a0, this.az, 25, 148);
            this.z = d.p1;
            this.v = d.p2;
            this.a0 = d.p3;
            this.az = d.p4;
            var e = this.a0;
            var f = this.az;
            var g = this.a5;
            if (this.am == null) {
                var h = (this.ai.getNativeElement());
                var i = h.getContext("2d");
                this.am = i;
            }
            if (g == null || g.length != (e * f) * 4) {
                this.aq = this.am.getImageData(0, 0, e, f);
                g = this.aq.data;
                this.a5 = g;
            }
            this.a.a2(g, e, f);
            this.am.putImageData(this.aq, 0, 0);
        }
    };
    ColorEditorPanelView.prototype.bk = function () {
        this.e = true;
        this.bm(this.k);
        this.bl(this.i);
        this.bn(this.q);
        this.bo(this.u, this.y, this.x);
        this.e = false;
    };
    ColorEditorPanelView.$t = markType(ColorEditorPanelView, 'ColorEditorPanelView');
    return ColorEditorPanelView;
}(Base));
export { ColorEditorPanelView };
/**
 * @hidden
 */
var ColorEditorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorEditorView, _super);
    function ColorEditorView() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.h = null;
        _this.d = null;
        _this.g = new List$1(Delegate_$type, 0);
        _this.e = true;
        _this.b = null;
        return _this;
    }
    ColorEditorView.prototype.q = function () {
    };
    ColorEditorView.prototype.f = function () {
        return true;
    };
    ColorEditorView.prototype.o = function (a) {
        var e_2, _a;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            this.g.clear();
            return;
        }
        if (this.a.a == null) {
            this.a.a = new DOMExecutionContext(a);
        }
        this.h = a;
        this.a.bg();
    };
    ColorEditorView.prototype.m = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.h;
        }
    };
    ColorEditorView.prototype.n = function () {
        this.e = true;
    };
    ColorEditorView.prototype.p = function () {
        this.e = false;
    };
    ColorEditorView.prototype.j = function () {
        return this.h;
    };
    ColorEditorView.prototype.i = function () {
        var a = new ColorEditorPanel();
        this.b = a;
        var b = this.h.createElement("div");
        var c = this.h.getSubRenderer(b);
        a.provideContainer(c);
        var d = this.h.getExternal(a, null, null);
        return b;
    };
    ColorEditorView.prototype.k = function (a, b) {
        var c = a.an;
        c.append(this.h.getWrapper(b));
    };
    ColorEditorView.prototype.l = function (a) {
        this.h.append(this.h.getWrapper(a.an));
    };
    ColorEditorView.prototype.c = function (a) {
        return this.b;
    };
    ColorEditorView.prototype.r = function (a) {
        if (this.h != null) {
            var b = this.h.rootWrapper.getNativeElement();
            var c = (b.getBoundingClientRect());
            if (a) {
                c = new Rect(0, c.left + window.pageXOffset, c.top + window.pageYOffset, c.width, c.height);
            }
            return c;
        }
        return null;
    };
    ColorEditorView.prototype.s = function () {
        return new Size(1, NaN, NaN);
    };
    ColorEditorView.$t = markType(ColorEditorView, 'ColorEditorView');
    return ColorEditorView;
}(Base));
export { ColorEditorView };
/**
 * @hidden
 */
var ColorEditor = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorEditor, _super);
    function ColorEditor() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.r = null;
        _this.q = null;
        _this.d = null;
        _this.v = false;
        _this.af = false;
        _this.ad = false;
        _this.cj = BrushUtil.h(0, 0, 0, 0);
        _this.w = false;
        _this.propertyChanged = null;
        _this.valueChanged = null;
        _this.valueChanging = null;
        _this.s = null;
        _this.a = null;
        _this.cl = BrushUtil.h(255, 0, 0, 255);
        _this.ar = "";
        _this.ci = BrushUtil.h(255, 24, 29, 31);
        _this.l = null;
        _this.j = 2;
        _this.h = 1;
        _this.m = null;
        _this.ck = BrushUtil.h(255, 24, 29, 31);
        _this.ch = BrushUtil.h(255, 163, 172, 184);
        _this.ac = true;
        _this.u = true;
        _this.ab = true;
        _this.x = false;
        _this.ap = 0;
        _this.y = false;
        _this.aa = false;
        _this.ae = false;
        _this.z = false;
        _this.gotFocus = null;
        _this.lostFocus = null;
        NativeUIInputsFactory.n();
        NativeUIXInputsFactory.m();
        var a = new ColorEditorView();
        a.a = _this;
        _this.g = a;
        _this.g.q();
        return _this;
    }
    ColorEditor.prototype.onAttachedToUI = function () {
        this.g.n();
    };
    ColorEditor.prototype.onDetachedFromUI = function () {
        this.g.p();
    };
    ColorEditor.prototype.b1 = function (a, b) {
        if (this.valueChanging != null) {
            this.valueChanging(this, ((function () {
                var $ret = new ColorEditorPanelSelectedValueChangedEventArgs();
                $ret.oldValue = a;
                $ret.newValue = b;
                return $ret;
            })()));
        }
        if (this.w) {
        }
    };
    ColorEditor.prototype.notifySizeChanged = function () {
    };
    ColorEditor.prototype.destroy = function () {
        this.provideContainer(null);
    };
    ColorEditor.prototype.provideContainer = function (a) {
        this.g.o(a);
    };
    Object.defineProperty(ColorEditor.prototype, "t", {
        get: function () {
            if (this.s == null) {
                this.s = new SRProvider(this.g.h);
                this.s.cb("ColorEditor");
            }
            return this.s;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "value", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cj = b;
            this.cl = a;
            if (b != this.cl) {
                this.b0("Value", b, this.cl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "az", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.b0("Label", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "cn", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.b0("LabelTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "o", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (b != this.l) {
                this.b0("LabelTextStyle", b, this.l);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "k", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.b0("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.j));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "i", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.b0("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.h));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "p", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.b0("TextStyle", b, this.m);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "co", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.b0("TextColor", b, this.ck);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "cm", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.b0("IconColor", b, this.ch);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "am", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.b0("ShowClearButton", b, this.ac);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "ag", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (b != this.u) {
                this.b0("AllowTextInput", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "ak", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.b0("OpenOnFocus", b, this.ab);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "ah", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.b0("IsDisabled", b, this.x);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.b0("TabIndex", b, this.ap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "ai", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.b0("IsFixed", b, this.y);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "aj", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.b0("OpenAsChild", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditor.prototype, "an", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.b0("UseTopLayer", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    ColorEditor.prototype.b0 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.b6(a, b, c);
    };
    ColorEditor.prototype.b6 = function (a, b, c) {
        switch (a) {
            case "Density":
                this.b9();
                break;
            case "BaseTheme":
                this.ca();
                break;
            case "Value":
                this.b1(this.cj, this.value);
                this.cj = this.value;
                if (this.d != null && !this.w) {
                    this.d.value = this.value;
                }
                break;
            case "Label":
                if (this.q != null) {
                    this.q.b5 = this.az;
                }
                break;
            case "TextStyle":
                this.cf();
                break;
            case "ShowClearButton":
                if (this.q != null) {
                    if (this.q.b7 != "") {
                    }
                }
                break;
            case "LabelTextColor":
            case "LabelTextStyle":
            case "TextColor":
            case "IconColor":
                this.cg();
                break;
            case "AllowTextInput":
                if (this.q != null) {
                    this.q.b0 = this.al();
                }
                break;
            case "OpenOnFocus": break;
            case "IsDisabled":
                {
                    if (this.q != null) {
                        this.q.b0 = this.al();
                    }
                }
                break;
        }
    };
    ColorEditor.prototype.al = function () {
        return this.ah || !this.ag;
    };
    ColorEditor.prototype.cg = function () {
        if (this.q != null) {
            this.q.ce = this.co;
        }
    };
    ColorEditor.prototype.ce = function () {
        if (this.q != null) {
        }
    };
    ColorEditor.prototype.cf = function () {
        if (this.m != null) {
            this.q.bk = this.m;
        }
    };
    ColorEditor.prototype.be = function () {
        if (this.ah == true) {
            return;
        }
        if (this.q != null) {
            this.q.b7 = "";
        }
        this.value = BrushUtil.h(0, 0, 0, 0);
        this.d.ax();
        this.z = false;
    };
    ColorEditor.prototype.by = function () {
        this.z = true;
    };
    ColorEditor.prototype.bz = function () {
        this.z = false;
    };
    ColorEditor.prototype.bo = function () {
        NativeUIWindow.h(15, runOn(this, this.b4), this.g.h);
        NativeUIWindow.h(9, runOn(this, this.b3), this.g.h);
    };
    ColorEditor.prototype.bs = function () {
        NativeUIWindow.i(15, runOn(this, this.b4));
        NativeUIWindow.i(9, runOn(this, this.b3));
    };
    ColorEditor.prototype.b3 = function (a) {
        var b = a;
        if (this.q != null) {
            if (this.r.b6 && !this.r.t(b.b) && !this.q.t(b.b)) {
                this.bf();
            }
        }
    };
    ColorEditor.prototype.b4 = function (a) {
        if (this.q != null) {
            var b = this.q.be();
            this.r.cd(b);
        }
    };
    ColorEditor.prototype.bg = function () {
        var _this = this;
        NativeUIComponent.av(this.g.j(), [12, 2, 7, 0], [2, 2, 2, 2], function (a) {
            var b = a[0];
            var c = a[1];
            var d = a[2];
            var e = a[3];
            var f = _this.g.i();
            _this.g.k(e, f);
            b.bn(d);
            d.bn(e);
            _this.g.l(c);
            b.cf = BrushUtil.h(255, 255, 255, 255);
            b.b9 = 150;
            b.b7 = 8;
            b.ca = 4;
            b.b1 = true;
            _this.q = c;
            _this.q.c = _this.i;
            _this.q.bp = _this.k;
            _this.q.b6 = ColorEditor.a5;
            _this.q.cc = BrushUtil.h(255, 255, 255, 255);
            _this.q.cd = BrushUtil.h(255, 0, 0, 0);
            _this.q.bn = runOn(_this, _this.cc);
            _this.q.n = runOn(_this, _this.bv);
            _this.q.o = runOn(_this, _this.bx);
            _this.q.cb = BrushUtil.h(255, 0, 0, 255);
            _this.r = b;
            _this.d = _this.g.c(f);
            _this.d.value = _this.value;
            var g = _this.d;
            g.closed = delegateCombine(g.closed, runOn(_this, _this.bc));
            var h = _this.d;
            h.valueChanged = delegateCombine(h.valueChanged, runOn(_this, _this.bd));
            d.o = runOn(_this, _this.bx);
            var i = _this.d;
            i.valueChanged = delegateCombine(i.valueChanged, runOn(_this, _this.bj));
        });
    };
    ColorEditor.prototype.bd = function (a, b) {
        if (this.valueChanged != null) {
            this.valueChanged(this, b);
        }
    };
    ColorEditor.prototype.bc = function (a, b) {
        this.bi(a);
    };
    ColorEditor.prototype.bx = function (a, b) {
        if (!this.r.t(b.b) && !this.q.t(b.b) && !(this.q.an == b.b)) {
            this.bm();
        }
    };
    ColorEditor.prototype.bv = function (a, b) {
        this.focus();
    };
    ColorEditor.prototype.cc = function (a, b) {
        this.cd();
    };
    ColorEditor.prototype.bj = function (a, b) {
        this.w = true;
        this.value = b.newValue;
        this.w = false;
        this.b2(b.oldValue, b.newValue);
    };
    ColorEditor.prototype.b2 = function (a, b) {
        if (this.q != null) {
            this.q.cb = b;
        }
    };
    ColorEditor.prototype.bi = function (a) {
        if (this.r.b6) {
            this.v = true;
            this.bf();
        }
    };
    ColorEditor.prototype.cd = function () {
        if (this.v == false) {
            if (this.r.b6) {
                this.bf();
            }
            else {
                this.b5();
            }
        }
        else {
            this.v = false;
        }
    };
    ColorEditor.prototype.b5 = function () {
        if (this.ah) {
            return;
        }
        if (this.r != null) {
            var a = this.g.r(false);
            var b = this.g.s();
            var c = b.height;
            var d = 240;
            var e = a.bottom + d;
            if (!isNaN_(c) && c < e) {
                var f = a.top - d;
                if (f < 0) {
                    this.cb(1, 0);
                }
                else {
                    this.cb(2, 0);
                }
            }
            else {
                this.cb(1, 0);
            }
        }
    };
    ColorEditor.prototype.cb = function (a, b) {
        {
            var c = this.g.r(true);
            this.r.ce(c, a, b);
        }
    };
    ColorEditor.prototype.bf = function () {
        var _this = this;
        if (this.r != null) {
            this.a.executeDelayed(function () { return _this.r.cb(); }, 0);
        }
        if (this.d != null) {
            this.d.bg();
        }
        this.v = false;
    };
    ColorEditor.prototype.focus = function (a) {
        var _this = this;
        if (a === void 0) {
            a = false;
        }
        if (this.q != null) {
            this.q.a0();
        }
        if (!this.r.b6 && this.ak == true) {
            if (this.v == false) {
                if (this.z) {
                    return;
                }
                if (this.ag == false) {
                    this.b5();
                    this.v = true;
                    this.a.executeDelayed(function () { return _this.bl(); }, 0);
                }
                else {
                    if (this.ak == true && this.ad == false) {
                        this.b5();
                        this.v = true;
                        this.a.executeDelayed(function () { return _this.bl(); }, 0);
                    }
                }
            }
            else {
                this.v = false;
            }
        }
    };
    ColorEditor.prototype.bm = function () {
        this.v = false;
    };
    ColorEditor.prototype.b8 = function () {
        if (this.q != null) {
            this.q.b9();
        }
    };
    ColorEditor.prototype.bl = function () {
        this.d.a3();
    };
    ColorEditor.prototype.bq = function () {
        var a = new ColorEditorGotFocusEventArgs();
        this.bu(a);
    };
    ColorEditor.prototype.br = function () {
        var a = new ColorEditorLostFocusEventArgs();
        this.bw(a);
    };
    ColorEditor.prototype.ca = function () {
    };
    ColorEditor.prototype.b9 = function () {
    };
    ColorEditor.prototype.bu = function (a) {
        if (null != this.gotFocus) {
            this.gotFocus(this, a);
        }
    };
    ColorEditor.prototype.bw = function (a) {
        if (null != this.lostFocus) {
            this.lostFocus(this, a);
        }
    };
    ColorEditor.$t = markType(ColorEditor, 'ColorEditor', Base.$, [INotifyPropertyChanged_$type]);
    ColorEditor.a5 = "M13.093 6.743a1.074 1.074 0 011.306.251l.237.237-6.4 6.4-.242-.231a1.074 1.074 0 01-.251-1.306c.446-.693 1.553-2.516.515-3.554-1.584-1.585-2.225-.94-3.809-2.528S2.714 3 3.354 2.354s2.073-.489 3.658 1.095.943 2.225 2.527 3.809c1.038 1.042 2.861-.069 3.554-.515zm6.93 5.874L15.31 7.9 8.9 14.31l4.433 4.433c-.039.159-.084.327-.137.508 0 0-.8 2.749.8 2.749s.8-2.749.8-2.749a10.75 10.75 0 01-.272-1.14L16.2 16.44a8.944 8.944 0 00-2.072-3.314s.555-.545 3.323 2.063l.811-.811-1.54-2.5 2.5 1.539z";
    ColorEditor.n = null;
    return ColorEditor;
}(Base));
export { ColorEditor };
/**
 * @hidden
 */
var ColorEditorPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorEditorPanel, _super);
    function ColorEditorPanel() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.bv = BrushUtil.h(0, 0, 0, 0);
        _this.bo = null;
        _this.bs = BrushUtil.h(0, 0, 0, 0);
        _this.propertyChanged = null;
        _this.closed = null;
        _this.valueChanged = null;
        _this.valueChanging = null;
        _this.v = null;
        _this.bx = BrushUtil.h(255, 0, 0, 255);
        _this.g = 3;
        _this.e = 1;
        _this.bp = BrushUtil.h(0, 255, 255, 255);
        _this.bt = BrushUtil.h(255, 33, 150, 243);
        _this.bu = BrushUtil.h(255, 21, 112, 184);
        _this.bq = BrushUtil.h(76, 33, 150, 243);
        _this.br = BrushUtil.h(50, 186, 191, 199);
        _this.bw = BrushUtil.h(255, 24, 29, 31);
        _this.i = null;
        _this.n = null;
        _this.s = null;
        _this.u = null;
        _this.m = null;
        _this.t = null;
        _this.o = null;
        _this.r = null;
        _this.q = null;
        _this.l = null;
        _this.k = null;
        _this.p = null;
        _this.aa = NaN;
        _this.z = 1;
        _this.y = false;
        _this.x = false;
        NativeUIInputsFactory.n();
        NativeUIXInputsFactory.m();
        _this.bo = BrushUtil.h(0, 0, 0, 0);
        var a = new ColorEditorPanelView();
        a.a = _this;
        _this.d = a;
        _this.d.bj();
        return _this;
    }
    ColorEditorPanel.prototype.a8 = function () {
        if (this.closed != null) {
            this.closed(this, new ColorEditorPanelClosedEventArgs());
        }
    };
    ColorEditorPanel.prototype.bc = function (a) {
        var b = this.bx;
        this.bx = a;
        if (this.valueChanged != null) {
            this.valueChanged(this, ((function () {
                var $ret = new ColorEditorPanelSelectedValueChangedEventArgs();
                $ret.oldValue = b;
                $ret.newValue = a;
                return $ret;
            })()));
        }
        this.bv = this.value;
    };
    ColorEditorPanel.prototype.notifySizeChanged = function (a) {
        this.d.bf(a);
    };
    ColorEditorPanel.prototype.destroy = function () {
        this.provideContainer(null);
    };
    ColorEditorPanel.prototype.provideContainer = function (a) {
        this.d.bh(a);
    };
    Object.defineProperty(ColorEditorPanel.prototype, "w", {
        get: function () {
            if (this.v == null) {
                this.v = new SRProvider(this.d.aa);
                this.v.cb("ColorEditorPanel");
            }
            return this.v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "value", {
        get: function () {
            return this.bx;
        },
        set: function (a) {
            var b = this.bx;
            this.bs = b;
            this.bx = a;
            if (b != this.bx) {
                this.bb("Value", b, this.bx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "h", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.bb("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.g));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "f", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.bb("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.e));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "by", {
        get: function () {
            return this.bp;
        },
        set: function (a) {
            var b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.bb("BackgroundColor", b, this.bp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "b1", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            var b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.bb("SelectedColorBorderColor", b, this.bt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "b2", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            var b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.bb("SelectedFocusColorBorderColor", b, this.bu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "bz", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.bb("FocusColorBorderColor", b, this.bq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "b0", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            var b = this.br;
            this.br = a;
            if (b != this.br) {
                this.bb("HoverBackgroundColor", b, this.br);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "b3", {
        get: function () {
            return this.bw;
        },
        set: function (a) {
            var b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.bb("TextColor", b, this.bw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.bb("TextStyle", b, this.i);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "ae", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.bb("PixelScalingRatio", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ColorEditorPanel.prototype, "ab", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.bb("ActualPixelScalingRatio", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    ColorEditorPanel.prototype.bb = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.bd(a, b, c);
    };
    ColorEditorPanel.prototype.bd = function (a, b, c) {
        switch (a) {
            case "Density":
                this.bi();
                break;
            case "BaseTheme":
                this.bj();
                break;
            case "Value":
                this.bs = this.value;
                this.bv = this.value;
                if (b != null && c != null) {
                    if (BrushUtil.d(b, c)) {
                        break;
                    }
                }
                this.bf();
                this.bc(this.value);
                break;
            case "TextColor":
            case "BackgroundColor":
            case "FocusColorBorderColor":
            case "SelectedFocusColorBorderColor":
            case "SelectedColorBorderColor":
            case "HoverBackgroundColor":
                this.bk();
                break;
            case "TextStyle":
                this.bl();
                break;
            case "PixelScalingRatio":
                if (!isNaN_(c)) {
                    this.ab = c;
                }
                break;
            case "ActualPixelScalingRatio":
                if (this.d != null) {
                    this.d.bk();
                }
                break;
        }
    };
    ColorEditorPanel.prototype.a4 = function () {
        var _this = this;
        NativeUIContent.av(this.d.a7(), [7, 7, 0, 5, 0, 5, 0, 5, 2, 7, 1, 1, 7, 2, 7], [2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2], function (a) {
            var b = a[0];
            var c = a[1];
            var d = a[2];
            var e = a[3];
            var f = a[4];
            var g = a[5];
            var h = a[6];
            var i = a[7];
            var j = a[8];
            var k = a[9];
            var l = a[10];
            var m = a[11];
            var n = a[12];
            var o = a[13];
            var p = a[14];
            e.bk = 2;
            i.bk = 0;
            g.bk = 1;
            e.bw = BrushUtil.h(0, 0, 0, 0);
            i.bw = BrushUtil.h(0, 0, 0, 0);
            g.bw = BrushUtil.h(0, 0, 0, 0);
            g.bh = new Thickness(1, 0, 5, 5, 0);
            f.bh = new Thickness(1, 0, 5, 5, 0);
            l.by = "Ok";
            l.c = _this.f;
            m.by = "Cancel";
            m.c = _this.f;
            i.bh = new Thickness(1, 5, 0, 5, 2);
            h.bh = new Thickness(1, 5, 0, 5, 2);
            e.bh = new Thickness(1, 5, 5, 5, 0);
            d.bh = new Thickness(1, 5, 5, 5, 0);
            p.bh = new Thickness(1, 5, 16, 0, 11);
            p.a8 = BrushUtil.h(255, 255, 0, 0);
            c.cc(p, 0);
            c.ca(p, 0);
            c.bn(p);
            n.b2(0, 2, 1);
            n.b2(1, 2, 1);
            n.bh = new Thickness(1, 5, 2, 5, 2);
            n.ca(j, 0);
            j.bh = new Thickness(1, 0, 0, 2, 0);
            j.bu = 1;
            j.bp = _this.h;
            j.c = _this.f;
            j.b5 = "rgba";
            o.bh = new Thickness(1, 0, 0, 2, 0);
            o.bu = 1;
            o.bp = _this.h;
            o.c = _this.f;
            o.b5 = "hex";
            n.ca(o, 1);
            n.bn(j);
            n.bn(o);
            l.bh = new Thickness(1, 5, 2, 5, 2);
            m.bh = new Thickness(1, 5, 2, 5, 2);
            l.bp = _this.h;
            m.bp = _this.h;
            l.bm = runOn(_this, _this.a6);
            m.bm = runOn(_this, _this.bh);
            b.b4(0, 1, 175);
            b.b4(1, 0, 0);
            b.b4(2, 0, 0);
            b.b4(3, 0, 0);
            b.b2(0, 1, 90);
            b.b2(1, 1, 175);
            b.b2(2, 1, 25);
            b.cc(c, 0);
            b.ca(c, 0);
            b.cc(d, 0);
            b.ca(d, 1);
            b.cc(e, 0);
            b.ca(e, 1);
            b.cc(f, 0);
            b.ca(f, 3);
            b.cc(g, 0);
            b.ca(g, 3);
            b.cc(h, 1);
            b.ca(h, 0);
            b.cb(h, 3);
            b.cc(i, 1);
            b.ca(i, 0);
            b.cb(i, 3);
            b.cc(n, 2);
            b.ca(n, 0);
            b.cb(n, 3);
            b.cc(k, 3);
            b.ca(k, 0);
            b.cb(k, 3);
            k.b2(0, 2, 1);
            k.b2(1, 2, 1);
            k.ca(l, 0);
            k.ca(m, 1);
            k.bn(l);
            k.bn(m);
            b.bn(c);
            b.bn(d);
            b.bn(e);
            b.bn(f);
            b.bn(g);
            b.bn(h);
            b.bn(i);
            b.bn(n);
            b.bn(k);
            _this.d.a8(b);
            _this.n = b;
            _this.n.bw = true;
            _this.s = i;
            _this.u = g;
            _this.m = f;
            _this.t = e;
            _this.o = p;
            _this.r = j;
            _this.q = o;
            _this.s.bq = 0;
            _this.s.bp = 360;
            _this.s.by = BrushUtil.h(255, 255, 255, 255);
            _this.s.bz = BrushUtil.h(255, 255, 255, 255);
            _this.u.bq = 0;
            _this.u.bp = 1;
            _this.t.by = BrushUtil.h(255, 155, 155, 155);
            _this.t.bz = BrushUtil.h(255, 255, 255, 255);
            _this.t.bq = 0;
            _this.t.bp = 1;
            _this.t.bu = 0;
            _this.t.bt = 1;
            _this.s.bo = runOn(_this, _this.au);
            _this.s.bn = runOn(_this, _this.au);
            _this.u.bo = runOn(_this, _this.aw);
            _this.u.bn = runOn(_this, _this.aw);
            _this.t.bo = runOn(_this, _this.av);
            _this.t.bn = runOn(_this, _this.av);
            _this.l = d;
            _this.k = h;
            _this.p = c;
            _this.ba();
        });
    };
    ColorEditorPanel.prototype.bh = function (a, b) {
        this.value = this.bs;
        this.a8();
    };
    ColorEditorPanel.prototype.a6 = function (a, b) {
        var _this = this;
        this.bs = this.value;
        if (this.valueChanged != null) {
            this.valueChanged(this, ((function () {
                var $ret = new ColorEditorPanelSelectedValueChangedEventArgs();
                $ret.oldValue = _this.bs;
                $ret.newValue = _this.value;
                return $ret;
            })()));
        }
        this.a8();
    };
    ColorEditorPanel.prototype.av = function (a, b) {
        this.bn();
    };
    ColorEditorPanel.prototype.aw = function (a, b) {
        this.bn();
    };
    ColorEditorPanel.prototype.bn = function () {
        if (this.y) {
            return;
        }
        var a = Color.u(0, 0, 0, 0);
        var b = Color.u(255, 255, 0, 0);
        if (this.s != null) {
            var c = this.s.bs;
            var d = this.t.bs;
            var e = 1 - this.t.bv;
            var f = 1 - this.u.bs;
            b = ColorUtil.r(1, c, 1, 0.5);
            a = ColorUtil.r(f, c, d, e);
            this.s.bx = BrushUtil.h(b.l, b.o, b.n, b.m);
            this.t.bx = BrushUtil.h(a.l, a.o, a.n, a.m);
            this.o.a8 = BrushUtil.h(a.l, a.o, a.n, a.m);
            this.d.bm(this.s.bs);
            this.d.bn(0);
            this.d.bo(this.s.bs, this.t.bs, 1 - this.t.bv);
        }
        if (this.r != null) {
            var g = a.o + ", " + a.n + ", " + a.m + ", " + Math.round((a.l / 255) * 1000) / 1000;
            this.r.b7 = g;
        }
        if (this.q != null) {
            var h = ColorUtil.k(a, false);
            this.q.b7 = h;
        }
        this.bx = BrushUtil.h(a.l, a.o, a.n, a.m);
        this.bc(this.value);
    };
    ColorEditorPanel.prototype.au = function (a, b) {
        this.bn();
    };
    ColorEditorPanel.prototype.bk = function () {
    };
    ColorEditorPanel.prototype.bl = function () {
    };
    ColorEditorPanel.prototype.a3 = function () {
        this.n.az();
    };
    ColorEditorPanel.prototype.onAttachedToUI = function () {
        this.d.bg();
    };
    ColorEditorPanel.prototype.onDetachedFromUI = function () {
        this.d.bi();
    };
    ColorEditorPanel.prototype.bj = function () {
    };
    ColorEditorPanel.prototype.bi = function () {
    };
    ColorEditorPanel.prototype.ax = function () {
        this.value = BrushUtil.h(0, 0, 0, 0);
    };
    Object.defineProperty(ColorEditorPanel.prototype, "b5", {
        get: function () {
            var a = ColorUtil.p(this.value);
            if (a.c) {
                return a.d;
            }
            return Color.u(255, 0, 0, 255);
        },
        enumerable: false,
        configurable: true
    });
    ColorEditorPanel.prototype.bf = function () {
        var a = this.b5;
        var b = ColorUtil.a(a);
        this.y = true;
        this.s.bs = b[1] == -1 ? 0 : b[1];
        this.u.bs = 1 - b[0];
        this.t.bs = b[2];
        this.t.bv = 1 - b[3];
        this.y = false;
        if (this.x) {
            this.bn();
        }
    };
    ColorEditorPanel.prototype.bm = function () {
    };
    ColorEditorPanel.prototype.bg = function () {
    };
    ColorEditorPanel.prototype.ba = function () {
        this.x = true;
        this.d.ba(this.l);
        this.d.a9(this.k);
        this.d.bb(this.p);
        this.d.bc(this.m);
        this.bf();
        this.bn();
    };
    ColorEditorPanel.prototype.a0 = function (a, b, c) {
        var d = this.s.bs;
        var e = 1;
        var f = 255;
        for (var g = 0; g < c; g++) {
            var h = g / c;
            for (var i = 0; i < b; i++) {
                var j = i / b;
                var k = j;
                var l = 1 - h;
                var m = void 0;
                var n = void 0;
                var o = void 0;
                if (k == 0) {
                    m = l;
                    n = l;
                    o = l;
                }
                else {
                    var p = l < 0.5 ? l * (1 + k) : l + k - (l * k);
                    var q = 2 * l - p;
                    var r = d / 360;
                    var s = r + 1 / 3;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        m = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        m = p;
                    }
                    else if (s < 2 / 3) {
                        m = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        m = q;
                    }
                    s = r;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        n = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        n = p;
                    }
                    else if (s < 2 / 3) {
                        n = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        n = q;
                    }
                    s = r - 1 / 3;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        o = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        o = p;
                    }
                    else if (s < 2 / 3) {
                        o = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        o = q;
                    }
                }
                m = m * 255;
                n = n * 255;
                o = o * 255;
                var t = truncate((m * e));
                var u = truncate((n * e));
                var v = truncate((o * e));
                var w = ((g * b) + i) * 4;
                a[w + 0] = t;
                a[w + 1] = u;
                a[w + 2] = v;
                a[w + 3] = f;
            }
        }
    };
    ColorEditorPanel.prototype.az = function (a, b, c) {
        var d = 1;
        var e = 255;
        for (var f = 0; f < c; f++) {
            var g = f / c;
            for (var h = 0; h < b; h++) {
                var i = h / b;
                var j = 1;
                var k = 0.5;
                var l = 360 * i;
                var m = void 0;
                var n = void 0;
                var o = void 0;
                if (j == 0) {
                    m = k;
                    n = k;
                    o = k;
                }
                else {
                    var p = k < 0.5 ? k * (1 + j) : k + j - (k * j);
                    var q = 2 * k - p;
                    var r = l / 360;
                    var s = r + 1 / 3;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        m = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        m = p;
                    }
                    else if (s < 2 / 3) {
                        m = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        m = q;
                    }
                    s = r;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        n = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        n = p;
                    }
                    else if (s < 2 / 3) {
                        n = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        n = q;
                    }
                    s = r - 1 / 3;
                    s = s < 0 ? s + 1 : s > 1 ? s - 1 : s;
                    if (s < 1 / 6) {
                        o = q + ((p - q) * 6 * s);
                    }
                    else if (s < 1 / 2) {
                        o = p;
                    }
                    else if (s < 2 / 3) {
                        o = q + ((p - q) * 6 * (2 / 3 - s));
                    }
                    else {
                        o = q;
                    }
                }
                m = m * 255;
                n = n * 255;
                o = o * 255;
                var t = truncate((m * d));
                var u = truncate((n * d));
                var v = truncate((o * d));
                var w = ((f * b) + h) * 4;
                a[w + 0] = t;
                a[w + 1] = u;
                a[w + 2] = v;
                a[w + 3] = e;
            }
        }
    };
    ColorEditorPanel.prototype.ad = function () {
        if (this.s != null) {
            return this.s.bs;
        }
        return 0;
    };
    ColorEditorPanel.prototype.a1 = function (a, b, c) {
        var d = this.s.bs;
        var e = 1;
        var f = 255;
        for (var g = 0; g < c; g++) {
            var h = g / c;
            for (var i = 0; i < b; i++) {
                var j = i / b;
                var k = ((intDivide(i, 10)) + (intDivide(g, 10))) % 2 == 0;
                var l = 100;
                var m = 100;
                var n = 100;
                if (!k) {
                    l = 255;
                    m = 255;
                    n = 255;
                }
                var o = truncate((l));
                var p = truncate((m));
                var q = truncate((n));
                if (o > 255) {
                    o = 255;
                }
                if (p > 255) {
                    p = 255;
                }
                if (q > 255) {
                    q = 255;
                }
                var r = ((g * b) + i) * 4;
                a[r + 0] = o;
                a[r + 1] = p;
                a[r + 2] = q;
                a[r + 3] = f;
            }
        }
    };
    ColorEditorPanel.prototype.a2 = function (a, b, c) {
        var d = this.s.bs;
        var e = 1;
        var f = 255;
        var g = 1 - this.t.bv;
        var h = this.t.bs;
        for (var i = 0; i < c; i++) {
            var j = i / c;
            for (var k = 0; k < b; k++) {
                var l = k / b;
                var m = h;
                var n = g;
                var o = void 0;
                var p = void 0;
                var q = void 0;
                if (m == 0) {
                    o = n;
                    p = n;
                    q = n;
                }
                else {
                    var r = n < 0.5 ? n * (1 + m) : n + m - (n * m);
                    var s = 2 * n - r;
                    var t = d / 360;
                    var u = t + 1 / 3;
                    u = u < 0 ? u + 1 : u > 1 ? u - 1 : u;
                    if (u < 1 / 6) {
                        o = s + ((r - s) * 6 * u);
                    }
                    else if (u < 1 / 2) {
                        o = r;
                    }
                    else if (u < 2 / 3) {
                        o = s + ((r - s) * 6 * (2 / 3 - u));
                    }
                    else {
                        o = s;
                    }
                    u = t;
                    u = u < 0 ? u + 1 : u > 1 ? u - 1 : u;
                    if (u < 1 / 6) {
                        p = s + ((r - s) * 6 * u);
                    }
                    else if (u < 1 / 2) {
                        p = r;
                    }
                    else if (u < 2 / 3) {
                        p = s + ((r - s) * 6 * (2 / 3 - u));
                    }
                    else {
                        p = s;
                    }
                    u = t - 1 / 3;
                    u = u < 0 ? u + 1 : u > 1 ? u - 1 : u;
                    if (u < 1 / 6) {
                        q = s + ((r - s) * 6 * u);
                    }
                    else if (u < 1 / 2) {
                        q = r;
                    }
                    else if (u < 2 / 3) {
                        q = s + ((r - s) * 6 * (2 / 3 - u));
                    }
                    else {
                        q = s;
                    }
                }
                o = o * 255;
                p = p * 255;
                q = q * 255;
                var v = e * (1 - j);
                var w = ((intDivide(k, 10)) + (intDivide(i, 10))) % 2 == 0;
                var x = 100;
                var y = 100;
                var z = 100;
                if (!w) {
                    x = 255;
                    y = 255;
                    z = 255;
                }
                var aa = truncate((o * v + x * (1 - v)));
                var ab = truncate((p * v + x * (1 - v)));
                var ac = truncate((q * v + x * (1 - v)));
                if (aa > 255) {
                    aa = 255;
                }
                if (ab > 255) {
                    ab = 255;
                }
                if (ac > 255) {
                    ac = 255;
                }
                var ad = ((i * b) + k) * 4;
                a[ad + 0] = aa;
                a[ad + 1] = ab;
                a[ad + 2] = ac;
                a[ad + 3] = f;
            }
        }
    };
    ColorEditorPanel.$t = markType(ColorEditorPanel, 'ColorEditorPanel', Base.$, [INotifyPropertyChanged_$type]);
    ColorEditorPanel.ag = "M15.41 16.59L10.83 12l4.58-4.59L14 6l-6 6 6 6 1.41-1.41z";
    ColorEditorPanel.ah = "M8.59 16.59L13.17 12 8.59 7.41 10 6l6 6-6 6-1.41-1.41z";
    return ColorEditorPanel;
}(Base));
export { ColorEditorPanel };
