import { ColorEditorPanelSelectedValueChangedEventArgs as ColorEditorPanelSelectedValueChangedEventArgs_internal } from "./ColorEditorPanelSelectedValueChangedEventArgs";
import { brushToString, stringToBrush } from "igniteui-react-core";
var IgrColorEditorPanelSelectedValueChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColorEditorPanelSelectedValueChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColorEditorPanelSelectedValueChangedEventArgs.prototype.createImplementation = function () {
        return new ColorEditorPanelSelectedValueChangedEventArgs_internal();
    };
    Object.defineProperty(IgrColorEditorPanelSelectedValueChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColorEditorPanelSelectedValueChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColorEditorPanelSelectedValueChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColorEditorPanelSelectedValueChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColorEditorPanelSelectedValueChangedEventArgs.prototype, "oldValue", {
        get: function () {
            return brushToString(this.i.oldValue);
        },
        set: function (v) {
            this.i.oldValue = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColorEditorPanelSelectedValueChangedEventArgs.prototype, "newValue", {
        get: function () {
            return brushToString(this.i.newValue);
        },
        set: function (v) {
            this.i.newValue = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrColorEditorPanelSelectedValueChangedEventArgs;
}());
export { IgrColorEditorPanelSelectedValueChangedEventArgs };
