import { IgrMultiSliderThumb } from "./igr-multi-slider-thumb";
import { MultiSliderThumbValueChangingEventArgs as MultiSliderThumbValueChangingEventArgs_internal } from "./MultiSliderThumbValueChangingEventArgs";
var IgrMultiSliderThumbValueChangingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrMultiSliderThumbValueChangingEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrMultiSliderThumbValueChangingEventArgs.prototype.createImplementation = function () {
        return new MultiSliderThumbValueChangingEventArgs_internal();
    };
    Object.defineProperty(IgrMultiSliderThumbValueChangingEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderThumbValueChangingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrMultiSliderThumbValueChangingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrMultiSliderThumbValueChangingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrMultiSliderThumbValueChangingEventArgs.prototype, "value", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrMultiSliderThumbValueChangingEventArgs.prototype, "thumb", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrMultiSliderThumb();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrMultiSliderThumbValueChangingEventArgs;
}());
export { IgrMultiSliderThumbValueChangingEventArgs };
