import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { SVGNode } from "igniteui-react-core";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { PrimitiveVisualData } from "igniteui-react-core";
import { IIcon } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
/**
 * @hidden
 */
export declare class IconView extends Base {
    static $t: Type;
    constructor();
    d: XIcon;
    ak(): void;
    l(): boolean;
    v: DomRenderer;
    private g;
    private o;
    get z(): any;
    get aa(): any;
    get c(): any[];
    get m(): boolean;
    q: List$1<Tuple$2<SVGNode, any>>;
    r: List$1<Tuple$2<SVGNode, any>>;
    s: List$1<Tuple$2<SVGNode, any>>;
    t: List$1<Tuple$2<SVGNode, any>>;
    u: List$1<Tuple$2<SVGNode, any>>;
    e: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    f: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    ai(a: DomRenderer): void;
    au(a: string): void;
    av(a: string[]): void;
    at(a: string): void;
    private ab;
    ap(a: string): void;
    as(a: any): void;
    private k;
    ar(): void;
    ax(): void;
    private n;
    am(a: Brush, b: string): void;
    an(a: any, b: Brush): void;
    ao(a: any, b: Brush): void;
    private ac;
    al(): void;
    private ad;
    private ae;
    private j;
    private y;
    private x;
    private w;
    private p;
    ag(): void;
    aj(): void;
    aw(a: FontInfo): void;
    b(): number[];
    private ah;
    a(): PrimitiveVisualData[];
    private af;
    private h;
    private aq;
    private i;
}
/**
 * @hidden
 */
export declare class XIcon extends Base implements INotifyPropertyChanged, IIcon {
    static $t: Type;
    constructor();
    private _view;
    get view(): IconView;
    set view(a: IconView);
    destroy(): void;
    protected ce(a: string, b: any, c: any): void;
    protected ch(a: string, b: any, c: any): void;
    private cl;
    protected get r(): boolean;
    private ck;
    private cj;
    private cg;
    static c2: Brush;
    static c7: Brush;
    static c6: Brush;
    static c3: Brush;
    static c4: Brush;
    static c5: Brush;
    static ai: number;
    static ah: number;
    private j;
    get k(): BaseControlTheme;
    set k(a: BaseControlTheme);
    private cm;
    get cz(): Brush;
    set cz(a: Brush);
    private cn;
    get c0(): Brush;
    set c0(a: Brush);
    private co;
    get c1(): Brush;
    set c1(a: Brush);
    private w;
    get ag(): number;
    set ag(a: number);
    private cp;
    get fill(): Brush;
    set fill(a: Brush);
    private cx;
    get df(): Brush;
    set df(a: Brush);
    private aa;
    get am(): number;
    set am(a: number);
    private cy;
    get dg(): Brush;
    set dg(a: Brush);
    private cq;
    get c8(): Brush;
    set c8(a: Brush);
    private cr;
    get c9(): Brush;
    set c9(a: Brush);
    private y;
    get ak(): number;
    set ak(a: number);
    private cs;
    get da(): Brush;
    set da(a: Brush);
    private c;
    get e(): BrushCollection;
    set e(a: BrushCollection);
    private d;
    get f(): BrushCollection;
    set f(a: BrushCollection);
    private ct;
    get db(): Brush;
    set db(a: Brush);
    private cu;
    get dc(): Brush;
    set dc(a: Brush);
    private cv;
    get dd(): Brush;
    set dd(a: Brush);
    private cw;
    get de(): Brush;
    set de(a: Brush);
    private av;
    get ax(): any;
    set ax(a: any);
    private az;
    get ba(): string;
    set ba(a: string);
    private a2;
    get svgPath(): string;
    set svgPath(a: string);
    private a1;
    get svg(): string;
    set svg(a: string);
    private a;
    get b(): string[];
    set b(a: string[]);
    cc(): void;
    cd(): void;
    private l;
    get m(): FontInfo;
    set m(a: FontInfo);
    private static au;
    private a0;
    get bk(): string;
    set bk(a: string);
    private as;
    private n;
    get q(): boolean;
    get at(): number;
    set at(a: number);
    private ay;
    get a7(): string;
    set a7(a: string);
    private p;
    get t(): boolean;
    set t(a: boolean);
    private o;
    get disabled(): boolean;
    set disabled(a: boolean);
    private z;
    get al(): number;
    set al(a: number);
    private ac;
    get ao(): number;
    set ao(a: number);
    private ad;
    get ap(): number;
    set ap(a: number);
    private ae;
    get aq(): number;
    set aq(a: number);
    private ab;
    get an(): number;
    set an(a: number);
    private af;
    get ar(): number;
    set ar(a: number);
    private x;
    get aj(): number;
    set aj(a: number);
    cf(): void;
    clicked: (sender: any, args: IconClickedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    v(): boolean;
    protected u(): boolean;
    aw(): any;
    bc(): string;
    g(): IconVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
