import { Base, INotifyPropertyChanged, PropertyChangedEventArgs, Type } from "igniteui-react-core";
import { ISliderTrackOwner } from "./ISliderTrackOwner";
import { MultiSliderThumbRangePosition } from "./MultiSliderThumbRangePosition";
import { IMultiSliderTrackThumbVisual } from "./IMultiSliderTrackThumbVisual";
import { IMultiSliderTrackThumbCalloutVisual } from "./IMultiSliderTrackThumbCalloutVisual";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class MultiSliderThumb extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private m;
    private o;
    private f;
    private h;
    private d;
    private l;
    private n;
    get e(): ISliderTrackOwner;
    set e(a: ISliderTrackOwner);
    protected u(a: string, b: any, c: any): void;
    private j;
    private k;
    private v;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    r(a: number): number;
    protected t(): void;
    get q(): number;
    set q(a: number);
    get p(): number;
    set p(a: number);
    get s(): number;
    set s(a: number);
    get g(): MultiSliderThumbRangePosition;
    set g(a: MultiSliderThumbRangePosition);
    get i(): MultiSliderTrackThumbRange;
    set i(a: MultiSliderTrackThumbRange);
    c: IMultiSliderTrackThumbVisual;
    b: IMultiSliderTrackThumbCalloutVisual;
}
/**
 * @hidden
 */
export declare class MultiSliderTrackThumbRange extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private i;
    private j;
    private h;
    private g;
    private d;
    private c;
    private a;
    protected t(a: string, b: any, c: any): void;
    private u;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected s(): void;
    get b(): ISliderTrackOwner;
    set b(a: ISliderTrackOwner);
    get n(): number;
    set n(a: number);
    o(a: number): number;
    p(a: number): number;
    private k;
    q(a: number): number;
    get r(): number;
    set r(a: number);
    get m(): number;
    set m(a: number);
    get l(): number;
    set l(a: number);
    get f(): MultiSliderThumb;
    set f(a: MultiSliderThumb);
    get e(): MultiSliderThumb;
    set e(a: MultiSliderThumb);
}
